#define __KERNEL__
#define MODULE

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/string.h>
#include <linux/sched.h>
#include <linux/fs.h>

void anotherfunc();

char searchstr[]="\x0f\x01\x15\xFF\xFF\xFF\xFF"
                 "\x0f\x01\x1d\xFF\xFF\xFF\xFF"
                 "\xea\xFF\xFF\xFF\xFF\xFF\xFF"
                 "\xb8\x18\x00\x00\x00\x8e\xd8\x8e\xc0\x8e\xe0\x8e\xe8";

char searchmask[]="1110000"
                  "1110000"
                  "1000000"
                  "1111111111111";

int testint;
int testint2;
char testchar1;

int foo()
{
	printk("FOOOOOOOOOOOOOOO! %d\n",1);
   printk("testint is %d, increasing by one ...\n",testint);
   testint++;
	return 0;
}

void asdf()
{
   struct task_struct *cur=get_current();
   struct fs_struct *f;
   struct dentry *d;
   f=cur->fs;
   printk("f = %p, cur = %p\n",f,cur);
   d=f->root;
   printk("d = %p\n",d);
   printk("name of the root filesystem: %s\n",d->d_sb->s_type->name);
}

int my_memcmp(const void * cs,const void * ct,char *mask,size_t count)
{
         const unsigned char *su1, *su2;
         char *m=mask;
         int res = 0;

         for( su1 = cs, su2 = ct; 0 < count; ++su1, ++su2, count--, ++m)
                 if (*m=='1' && (res = *su1 - *su2) != 0)
                         break;
         return res;
}

void *my_memmem(void *start, void *cmp, char *cmpmask, size_t cmplen, size_t count)
{
   size_t i;
   void *rval=0;
   for(i=0;i<count && rval==0;i++)
   {
      if(my_memcmp(start,cmp,cmpmask,cmplen)==0)
         rval=start;
      else
         start++;
   }
   return rval;
}



int init_module()
{
   char *ptr;
	printk("initializing module\n");
   testint=1;
	foo();
   printk("bla bla doing weird stuff and don't care to find out where the strings are bla bla...\n");
   printk("testint is now %d\n",testint);
   anotherfunc();
   printk("testint is now %d (final value)\n",testint);

   printk("current = %p\n",get_current());
   printk("current pid: %u\n",get_current()->pid);

   asdf();

   printk("searching for searchstr...");
   ptr=(char *)0xc0000000;
   ptr=my_memmem(ptr,searchstr,searchmask,13,0xc0300000-0xc0000000);
   if(ptr)
   {
      printk("found at 0x%08x\n",ptr);
      ptr=my_memmem(ptr+1,searchstr,searchmask,13,0xc0300000-0xc0000000);
      if(ptr)
      {
         printk("found at 0x%08x\n",ptr);
      }
      else
      {
         printk("not found\n");
      }
   }
   else
   {
      printk("not found\n");
   }

	return 0;
}

void anotherfunc()
{
        printk("bla bla... testint is %d (increasing by one)\n",testint);
        testint++;
}

